diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/emlsr-manager.cc ns-3.43/src/wifi/model/eht/emlsr-manager.cc
--- ns-3.42/src/wifi/model/eht/emlsr-manager.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/emlsr-manager.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -76,7 +65,7 @@
                               TypeId::ATTR_CONSTRUCT, // prevent setting after construction
                           UintegerValue(20),
                           MakeUintegerAccessor(&EmlsrManager::m_auxPhyMaxWidth),
-                          MakeUintegerChecker<uint16_t>(20, 160))
+                          MakeUintegerChecker<MHz_u>(20, 160))
             .AddAttribute("AuxPhyMaxModClass",
                           "The maximum modulation class supported by Aux PHYs. Use "
                           "WIFI_MOD_CLASS_OFDM for non-HT.",
@@ -104,6 +93,14 @@
                           MakeBooleanAccessor(&EmlsrManager::SetAuxPhyTxCapable,
                                               &EmlsrManager::GetAuxPhyTxCapable),
                           MakeBooleanChecker())
+            .AddAttribute("InDeviceInterference",
+                          "Whether in-device interference is such that a PHY cannot decode "
+                          "anything and cannot decrease the backoff counter when another PHY "
+                          "of the same device is transmitting.",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&EmlsrManager::SetInDeviceInterference,
+                                              &EmlsrManager::GetInDeviceInterference),
+                          MakeBooleanChecker())
             .AddAttribute(
                 "EmlsrLinkSet",
                 "IDs of the links on which EMLSR mode will be enabled. An empty set "
@@ -169,6 +166,13 @@
     m_staMac->TraceConnectWithoutContext("AckedMpdu", MakeCallback(&EmlsrManager::TxOk, this));
     m_staMac->TraceConnectWithoutContext("DroppedMpdu",
                                          MakeCallback(&EmlsrManager::TxDropped, this));
+    DoSetWifiMac(mac);
+}
+
+void
+EmlsrManager::DoSetWifiMac(Ptr<StaWifiMac> mac)
+{
+    NS_LOG_FUNCTION(this << mac);
 }
 
 void
@@ -209,6 +213,18 @@
     return m_auxPhyTxCapable;
 }
 
+void
+EmlsrManager::SetInDeviceInterference(bool enable)
+{
+    m_inDeviceInterference = enable;
+}
+
+bool
+EmlsrManager::GetInDeviceInterference() const
+{
+    return m_inDeviceInterference;
+}
+
 const std::set<uint8_t>&
 EmlsrManager::GetEmlsrLinks() const
 {
@@ -366,20 +382,15 @@
         if (id != linkId && m_staMac->IsEmlsrLink(id))
         {
             m_staMac->BlockTxOnLink(id, WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
-            m_staMac->GetChannelAccessManager(id)->NotifyStartUsingOtherEmlsrLink();
         }
     }
 
     auto mainPhy = m_staMac->GetDevice()->GetPhy(m_mainPhyId);
     auto auxPhy = m_staMac->GetWifiPhy(linkId);
 
-    if (m_staMac->GetWifiPhy(linkId) == mainPhy)
+    if (m_staMac->GetWifiPhy(linkId) != mainPhy)
     {
-        // nothing to do, we received an ICF from the main PHY
-        return;
-    }
-
-    Simulator::ScheduleNow([=, this]() {
+        // an aux PHY received the ICF
         SwitchMainPhy(linkId,
                       true, // channel switch should occur instantaneously
                       RESET_BACKOFF,
@@ -388,13 +399,49 @@
         // aux PHY received the ICF but main PHY will send the response
         auto uid = auxPhy->GetPreviouslyRxPpduUid();
         mainPhy->SetPreviouslyRxPpduUid(uid);
+    }
 
-        DoNotifyIcfReceived(linkId);
-    });
+    DoNotifyIcfReceived(linkId);
+}
+
+std::pair<bool, Time>
+EmlsrManager::GetDelayUntilAccessRequest(uint8_t linkId, AcIndex aci)
+{
+    auto phy = m_staMac->GetWifiPhy(linkId);
+    NS_ASSERT_MSG(phy, "No PHY operating on link " << +linkId);
+
+    auto mainPhy = m_staMac->GetDevice()->GetPhy(m_mainPhyId);
+
+    // check possible reasons to give up the TXOP that apply to both main PHY and aux PHYs
+    if (const auto [startTxop, delay] = DoGetDelayUntilAccessRequest(linkId); !startTxop)
+    {
+        return {false, delay};
+    }
+
+    if (phy == mainPhy)
+    {
+        // no more constraints to check if medium was gained by main PHY
+        return {true, Time{0}};
+    }
+
+    // an aux PHY is operating on the given link; call the appropriate method depending on
+    // whether the aux PHY is TX capable or not
+    if (!m_auxPhyTxCapable)
+    {
+        SwitchMainPhyIfTxopGainedByAuxPhy(linkId, aci);
+        // if the aux PHY is not TX capable, we don't have to request channel access: if the main
+        // PHY switches link, the UL TXOP will be started; if the main PHY does not switch, it is
+        // because it is going to start an UL TXOP on another link and this link will be restarted
+        // at the end of that UL TXOP when this link will be unblocked
+        NS_LOG_DEBUG("Aux PHY is not capable of transmitting a PPDU");
+        return {false, Time{0}};
+    }
+
+    return GetDelayUnlessMainPhyTakesOverUlTxop(linkId);
 }
 
 void
-EmlsrManager::NotifyUlTxopStart(uint8_t linkId, std::optional<Time> timeToCtsEnd)
+EmlsrManager::NotifyUlTxopStart(uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << linkId);
 
@@ -410,39 +457,9 @@
         if (id != linkId && m_staMac->IsEmlsrLink(id))
         {
             m_staMac->BlockTxOnLink(id, WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
-            m_staMac->GetChannelAccessManager(id)->NotifyStartUsingOtherEmlsrLink();
         }
     }
 
-    // if this TXOP is being started by an aux PHY, schedule a channel switch for the main PHY
-    // such that the channel switch is completed by the time the CTS response is received. The
-    // delay has been passed by the FEM.
-    if (m_staMac->GetLinkForPhy(m_mainPhyId) != linkId)
-    {
-        auto stateHelper = m_staMac->GetWifiPhy(linkId)->GetState();
-        NS_ASSERT(stateHelper);
-        NS_ASSERT_MSG(stateHelper->GetState() == WifiPhyState::TX,
-                      "Expecting the aux PHY to be transmitting (an RTS frame)");
-        NS_ASSERT_MSG(timeToCtsEnd.has_value(),
-                      "Aux PHY is sending RTS, expected to get the time to CTS end");
-
-        auto mainPhy = m_staMac->GetDevice()->GetPhy(m_mainPhyId);
-
-        // the main PHY shall terminate the channel switch at the end of CTS reception;
-        // the time remaining to the end of CTS reception includes two propagation delays
-        const auto delay = *timeToCtsEnd - mainPhy->GetChannelSwitchDelay();
-
-        NS_ASSERT(delay.IsPositive());
-        NS_LOG_DEBUG("Schedule main Phy switch in " << delay.As(Time::US));
-        m_ulMainPhySwitch[linkId] = Simulator::Schedule(delay,
-                                                        &EmlsrManager::SwitchMainPhy,
-                                                        this,
-                                                        linkId,
-                                                        false,
-                                                        RESET_BACKOFF,
-                                                        DONT_REQUEST_ACCESS);
-    }
-
     DoNotifyUlTxopStart(linkId);
 }
 
@@ -497,7 +514,6 @@
         {
             if ((id != linkId) && m_staMac->IsEmlsrLink(id))
             {
-                m_staMac->GetChannelAccessManager(id)->NotifyStopUsingOtherEmlsrLink();
                 linkIds.insert(id);
             }
         }
@@ -549,24 +565,24 @@
     NS_ASSERT_MSG(mainPhy != m_staMac->GetWifiPhy(linkId),
                   "Main PHY is already operating on link " << +linkId);
 
-    if (mainPhy->IsStateSwitching())
-    {
-        NS_LOG_DEBUG("Main PHY is already switching, ignore new switching request");
-        return;
-    }
-
     // find the link on which the main PHY is operating
     auto currMainPhyLinkId = m_staMac->GetLinkForPhy(mainPhy);
-    NS_ASSERT_MSG(currMainPhyLinkId, "Current link ID for main PHY not found");
 
-    auto newMainPhyChannel = GetChannelForMainPhy(linkId);
+    NS_ASSERT_MSG(currMainPhyLinkId.has_value() || mainPhy->IsStateSwitching(),
+                  "If the main PHY is not operating on a link, it must be switching");
+
+    const auto newMainPhyChannel = GetChannelForMainPhy(linkId);
 
     NS_LOG_DEBUG("Main PHY (" << mainPhy << ") is about to switch to " << newMainPhyChannel
                               << " to operate on link " << +linkId);
 
-    // notify the channel access manager of the upcoming channel switch(es)
-    m_staMac->GetChannelAccessManager(*currMainPhyLinkId)
-        ->NotifySwitchingEmlsrLink(mainPhy, newMainPhyChannel, linkId);
+    // if the main PHY is operating on a link, notify the channel access manager of the upcoming
+    // channel switch
+    if (currMainPhyLinkId.has_value())
+    {
+        m_staMac->GetChannelAccessManager(*currMainPhyLinkId)
+            ->NotifySwitchingEmlsrLink(mainPhy, newMainPhyChannel, linkId);
+    }
 
     // this assert also ensures that the actual channel switch is not delayed
     NS_ASSERT_MSG(!mainPhy->GetState()->IsStateTx(),
@@ -597,14 +613,21 @@
         mainPhy->SetSlot(MicroSeconds(9));
     }
 
-    if (resetBackoff)
+    const auto timeToSwitchEnd = noSwitchDelay ? Seconds(0) : delay;
+
+    // if the main PHY is not operating on any link (because it was switching), it is not connected
+    // to a channel access manager, hence we must notify the MAC of the new link switch
+    if (!currMainPhyLinkId.has_value())
+    {
+        m_staMac->NotifySwitchingEmlsrLink(mainPhy, linkId, timeToSwitchEnd);
+    }
+
+    if (resetBackoff && currMainPhyLinkId.has_value())
     {
         // reset the backoffs on the link left by the main PHY
         m_staMac->GetChannelAccessManager(*currMainPhyLinkId)->ResetAllBackoffs();
     }
 
-    const auto timeToSwitchEnd = noSwitchDelay ? Seconds(0) : mainPhy->GetChannelSwitchDelay();
-
     if (requestAccess)
     {
         // schedule channel access request on the new link when switch is completed
@@ -620,15 +643,13 @@
     }
 
     SetCcaEdThresholdOnLinkSwitch(mainPhy, linkId);
-    NotifyMainPhySwitch(*currMainPhyLinkId, linkId);
+    NotifyMainPhySwitch(currMainPhyLinkId, linkId, timeToSwitchEnd);
 }
 
 void
-EmlsrManager::SwitchAuxPhy(uint8_t currLinkId, uint8_t nextLinkId)
+EmlsrManager::SwitchAuxPhy(Ptr<WifiPhy> auxPhy, uint8_t currLinkId, uint8_t nextLinkId)
 {
-    NS_LOG_FUNCTION(this << currLinkId << nextLinkId);
-
-    auto auxPhy = GetStaMac()->GetWifiPhy(currLinkId);
+    NS_LOG_FUNCTION(this << auxPhy << currLinkId << nextLinkId);
 
     auto newAuxPhyChannel = GetChannelForAuxPhy(nextLinkId);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/emlsr-manager.h ns-3.43/src/wifi/model/eht/emlsr-manager.h
--- ns-3.42/src/wifi/model/eht/emlsr-manager.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -29,6 +18,9 @@
 #include <map>
 #include <optional>
 #include <set>
+#include <utility>
+
+class EmlsrCcaBusyTest;
 
 namespace ns3
 {
@@ -45,6 +37,9 @@
  */
 class EmlsrManager : public Object
 {
+    /// Allow test cases to access private members
+    friend class ::EmlsrCcaBusyTest;
+
   public:
     /**
      * \brief Get the type ID.
@@ -148,6 +143,18 @@
     bool GetCamStateReset() const;
 
     /**
+     * Notify that an UL TXOP is gained on the given link by the given AC. This method has to
+     * determine whether to start the UL TXOP or release the channel.
+     *
+     * \param linkId the ID of the given link
+     * \param aci the index of the given AC
+     * \return a pair consisting of a boolean value indicating whether the UL TXOP can be started
+     *         and a Time value indicating the delay after which the EMLSR client must restart
+     *         channel access (if needed) in case the UL TXOP is not started
+     */
+    std::pair<bool, Time> GetDelayUntilAccessRequest(uint8_t linkId, AcIndex aci);
+
+    /**
      * Set the member variable indicating whether Aux PHYs are capable of transmitting PPDUs.
      *
      * \param capable whether Aux PHYs are capable of transmitting PPDUs
@@ -160,6 +167,21 @@
     bool GetAuxPhyTxCapable() const;
 
     /**
+     * Set the member variable indicating whether in-device interference is such that a PHY cannot
+     * decode anything and cannot decrease the backoff counter when another PHY is transmitting.
+     *
+     * \param enable whether in-device interference is such that a PHY cannot decode anything
+     *               and cannot decrease the backoff counter when another PHY is transmitting
+     */
+    void SetInDeviceInterference(bool enable);
+
+    /**
+     * \return whether in-device interference is such that a PHY cannot decode anything and cannot
+     *         decrease the backoff counter when another PHY is transmitting
+     */
+    bool GetInDeviceInterference() const;
+
+    /**
      * Notify the reception of a management frame addressed to us.
      *
      * \param mpdu the received MPDU
@@ -178,10 +200,8 @@
      * Notify the start of an UL TXOP on the given link
      *
      * \param linkId the ID of the given link
-     * \param timeToCtsEnd time remaining to the end of CTS reception, in case the UL TXOP is
-     *                     started by an aux PHY
      */
-    void NotifyUlTxopStart(uint8_t linkId, std::optional<Time> timeToCtsEnd);
+    void NotifyUlTxopStart(uint8_t linkId);
 
     /**
      * Notify the end of a TXOP on the given link.
@@ -246,6 +266,13 @@
     void DoDispose() override;
 
     /**
+     * Allow subclasses to take actions when the MAC is set.
+     *
+     * \param mac the wifi MAC
+     */
+    virtual void DoSetWifiMac(Ptr<StaWifiMac> mac);
+
+    /**
      * \return the MAC of the non-AP MLD managed by this EMLSR Manager.
      */
     Ptr<StaWifiMac> GetStaMac() const;
@@ -306,10 +333,11 @@
      * Switch channel on the Aux PHY operating on the given current link so that it operates
      * on the given next link.
      *
+     * \param auxPhy the Aux PHY
      * \param currLinkId the ID of the link on which the aux PHY is currently operating
      * \param nextLinkId the ID of the link on which the aux PHY will be operating
      */
-    void SwitchAuxPhy(uint8_t currLinkId, uint8_t nextLinkId);
+    void SwitchAuxPhy(Ptr<WifiPhy> auxPhy, uint8_t currLinkId, uint8_t nextLinkId);
 
     /**
      * Set the CCA ED threshold (if needed) on the given PHY that is switching channel to
@@ -325,12 +353,52 @@
      */
     MgtEmlOmn GetEmlOmn();
 
+    /**
+     * Subclasses have to provide an implementation for this method, that is called by the base
+     * class when the EMLSR client gets channel access on the given link. This method has to
+     * check possible reasons to give up the TXOP that apply to both main PHY and aux PHYs.
+     *
+     * \param linkId the ID of the given link
+     * \return a pair consisting of a boolean value indicating whether the UL TXOP can be started
+     *         and a Time value indicating the delay after which the EMLSR client must restart
+     *         channel access (if needed) in case the UL TXOP is not started
+     */
+    virtual std::pair<bool, Time> DoGetDelayUntilAccessRequest(uint8_t linkId) = 0;
+
+    /**
+     * Subclasses have to provide an implementation for this method, that is called by the base
+     * class when the given AC of the EMLSR client gets channel access on the given link, on which
+     * an aux PHY that is not TX capable is operating. This method has to request the main PHY to
+     * switch to the given link to take over the TXOP, unless it is decided to give up the TXOP.
+     *
+     * \param linkId the ID of the given link
+     * \param aci the index of the given AC
+     */
+    virtual void SwitchMainPhyIfTxopGainedByAuxPhy(uint8_t linkId, AcIndex aci) = 0;
+
+    /**
+     * Subclasses have to provide an implementation for this method, that is called by the base
+     * class when the EMLSR client gets channel access on the given link, on which an aux PHY that
+     * is TX capable is operating. This method has to request the main PHY to switch to the
+     * given link to take over the TXOP, if possible, or determine the delay after which the
+     * EMLSR client restarts channel access on the given link, otherwise.
+     *
+     * \param linkId the ID of the given link
+     * \return a pair consisting of a boolean value indicating whether the UL TXOP can be started
+     *         and a Time value indicating the delay after which the EMLSR client must restart
+     *         channel access (if needed) in case the UL TXOP is not started
+     */
+    virtual std::pair<bool, Time> GetDelayUnlessMainPhyTakesOverUlTxop(uint8_t linkId) = 0;
+
     Time m_emlsrPaddingDelay;    //!< EMLSR Padding delay
     Time m_emlsrTransitionDelay; //!< EMLSR Transition delay
     uint8_t m_mainPhyId; //!< ID of main PHY (position in the vector of PHYs held by WifiNetDevice)
-    uint16_t m_auxPhyMaxWidth;               //!< max channel width (MHz) supported by aux PHYs
+    MHz_u m_auxPhyMaxWidth;                  //!< max channel width supported by aux PHYs
     WifiModulationClass m_auxPhyMaxModClass; //!< max modulation class supported by aux PHYs
     bool m_auxPhyTxCapable;                  //!< whether Aux PHYs are capable of transmitting PPDUs
+    std::map<uint8_t, EventId> m_ulMainPhySwitch; //!< link ID-indexed map of timers started when
+                                                  //!< an aux PHY gains an UL TXOP and schedules
+                                                  //!< a channel switch for the main PHY
 
   private:
     /**
@@ -434,10 +502,13 @@
     /**
      * Notify subclass that the main PHY is switching channel to operate on another link.
      *
-     * \param currLinkId the ID of the link on which the main PHY is operating
+     * \param currLinkId the ID of the link on which the main PHY is operating (if any)
      * \param nextLinkId the ID of the link on which the main PHY will be operating
+     * \param duration the channel switch duration
      */
-    virtual void NotifyMainPhySwitch(uint8_t currLinkId, uint8_t nextLinkId) = 0;
+    virtual void NotifyMainPhySwitch(std::optional<uint8_t> currLinkId,
+                                     uint8_t nextLinkId,
+                                     Time duration) = 0;
 
     /**
      * Information about the status of the MediumSyncDelay timer associated with a link.
@@ -458,10 +529,10 @@
 
     std::map<uint8_t, MediumSyncDelayStatus>
         m_mediumSyncDelayStatus; //!< the status of MediumSyncDelay timers (link ID-indexed)
-    std::map<Ptr<WifiPhy>, double> m_prevCcaEdThreshold; //!< the CCA sensitivity threshold (dBm)
-                                                         //!< to restore once the MediumSyncDelay
-                                                         //!< timer expires or the PHY moves to a
-                                                         //!< link on which the timer is not running
+    std::map<Ptr<WifiPhy>, dBm_u> m_prevCcaEdThreshold; //!< the CCA sensitivity threshold
+                                                        //!< to restore once the MediumSyncDelay
+                                                        //!< timer expires or the PHY moves to a
+                                                        //!< link on which the timer is not running
 
     std::set<uint8_t> m_emlsrLinks; //!< ID of the EMLSR links (empty if EMLSR mode is disabled)
     std::optional<std::set<uint8_t>> m_nextEmlsrLinks; /**< ID of the links that will become the
@@ -472,13 +543,13 @@
     EventId m_transitionTimeoutEvent; /**< Timer started after the successful transmission of an
                                            EML Operating Mode Notification frame */
     bool m_resetCamState; //!< whether to reset the state of CAM when main PHY switches channel
+    bool m_inDeviceInterference; //!< whether in-device interference is such that a PHY cannot
+                                 //!< decode anything  and cannot decrease the backoff counter
+                                 //!< when another PHY is transmitting
     std::map<uint8_t, WifiPhyOperatingChannel>
         m_mainPhyChannels; //!< link ID-indexed map of operating channels for the main PHY
     std::map<uint8_t, WifiPhyOperatingChannel>
         m_auxPhyChannels; //!< link ID-indexed map of operating channels for the aux PHYs
-    std::map<uint8_t, EventId> m_ulMainPhySwitch; //!< link ID-indexed map of timers started when
-                                                  //!< an aux PHY gains an UL TXOP and schedules
-                                                  //!< a channel switch for the main PHY
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/multi-link-element.cc ns-3.43/src/wifi/model/eht/multi-link-element.cc
--- ns-3.42/src/wifi/model/eht/multi-link-element.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/multi-link-element.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/multi-link-element.h ns-3.43/src/wifi/model/eht/multi-link-element.h
--- ns-3.42/src/wifi/model/eht/multi-link-element.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/multi-link-element.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/tid-to-link-mapping-element.cc ns-3.43/src/wifi/model/eht/tid-to-link-mapping-element.cc
--- ns-3.42/src/wifi/model/eht/tid-to-link-mapping-element.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/tid-to-link-mapping-element.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sharan Naribole <sharan.naribole@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/tid-to-link-mapping-element.h ns-3.43/src/wifi/model/eht/tid-to-link-mapping-element.h
--- ns-3.42/src/wifi/model/eht/tid-to-link-mapping-element.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/tid-to-link-mapping-element.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sharan Naribole <sharan.naribole@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/error-rate-model.cc ns-3.43/src/wifi/model/error-rate-model.cc
--- ns-3.42/src/wifi/model/error-rate-model.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/error-rate-model.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -73,7 +62,7 @@
     if (mode.GetModulationClass() == WIFI_MOD_CLASS_DSSS ||
         mode.GetModulationClass() == WIFI_MOD_CLASS_HR_DSSS)
     {
-        switch (mode.GetDataRate(22, 0, 1))
+        switch (mode.GetDataRate(22))
         {
         case 1000000:
             return DsssErrorRateModel::GetDsssDbpskSuccessRate(snr, nbits);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/error-rate-model.h ns-3.43/src/wifi/model/error-rate-model.h
--- ns-3.42/src/wifi/model/error-rate-model.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/error-rate-model.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
